#!/usr/bin/env python

import sys, base64

VERSIONEER_b64 = """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"""
newver = "0.26"

VERSIONEER_PEP518 = True

VERSIONEER = base64.b64decode(VERSIONEER_b64.encode('ASCII'))


# Stub overwritten by exec()
def setup_command(): ...

# Make versioneer usable via import
exec(VERSIONEER.decode(), globals())


def detect_installed_version() -> str:
    """Find version string in vendored versioneer

    Raises FileNotFoundError if missing.
    """
    with open("versioneer.py") as fobj:
        for i, line in enumerate(fobj):
            if line.startswith("# Version: "):
                return line[len("# Version: "):].strip()
            if i > 5:
                break
    return "unknown version"


def vendor():
    """Install versioneer into current directory"""
    try:
        oldver = detect_installed_version()
    except FileNotFoundError:
        pass
    else:
        print(f"replacing old versioneer.py ({oldver})")

    with open("versioneer.py", "wb") as fobj:
        fobj.write(VERSIONEER)
    print(f"versioneer.py ({newver}) installed into local tree")


def main():
    usage = "Usage: versioneer install [--vendor|--no-vendor]"
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        print(usage)
        sys.exit(1)

    command = sys.argv[1]
    mode = "--vendor" if len(sys.argv) == 2 else sys.argv[2]

    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)
    elif command in ("help", "-help", "--help"):
        print(usage)
        sys.exit(0)
    elif command != "install" or mode not in ("--vendor", "--no-vendor"):
        print(usage)
        sys.exit(1)

    if mode == "--vendor":
        vendor()
        print("Now running 'versioneer.py setup' to install the generated files..")

    setup_command()


if __name__ == '__main__':
    main()
